#ifndef _file_handle_h
#define _file_handle_h

#include "treedef.h"

#define STRINGLEN_MAX 7500  /* technical, buffer upper limit */
                            /* mustn't exceed <limits.h> INT_MAX */
                            
/* actualy we also assume sum of all string length to fit into an int
   therefore if sizeof(int)=2 expect to fail on long data-set files */



void read_alphabet (int *absizep, char **ABp, const char *filename);

void read_fasta_set (char **data_setp, int *mp, char ***ds_ptrp, \
		     int **lip, const char *AB, const char *filename, \
		     const char *indfile, int *tez, int *trz, int *trl);
		     
void predict_fasta_set (double gam_min, int n_mean, const char *out_file, \
			spst_type T, char *AB, const char *filename, \
			const char *indfile, int *tez, int *trz, int *trl);		     

void save_spst (char *outfile, char *AB, int absize, int L_max, spst_type T);

void load_spst (char *spstfile, char **ABp, int *absizep, int *L_maxp, 
	       spst_type *Tp);

#endif /*_file_handle_h */



