#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "queue.h"



/* local */



q_node *make_queue_node (int key, int depth_s, int L, char **vect, int absize)
{
  q_node *node;
  int i,len;
    
  if ((node = (q_node *) malloc (sizeof(q_node))) == NULL)
    {
      fprintf (stderr,"make_queue_node(): queue.c: failed to allocate queue node\n");
      exit(1);
    }
  if ((node->v = (char **) malloc(depth_s*sizeof(char *))) == NULL)
    {
      fprintf (stderr,"make_queue_node(): queue.c: failed to allocate queue node sequence\n");
      exit(1);
    }
  len = 0;
  for (i=1;i<=depth_s;i++)
    len += strlen(vect[L-i]);
  if ((node->v[0] = (char *) malloc(len+depth_s)) == NULL)
    {
      fprintf (stderr,"make_queue_node(): queue.c: failed to allocate queue node sequence\n");
      exit(1);
    }
  strcpy(node->v[0], vect[L-1]);
  for (i=1;i<depth_s;i++)
    {
      node->v[i] = node->v[i-1] + strlen(vect[L-i]) + 1;
      strcpy(node->v[i], vect[L-i-1]);
    }
  node->key = key;
  node->depth_s = depth_s;
  node->next = NULL;
  return(node);
}



void free_queue_node (q_node *q)
{     
  int i;
  if (q != NULL)
    {
      if (q->v != NULL)
	{
	  if (q->v[0] != NULL)
	    free(q->v[0]);
	  free(q->v);
	}
      free(q);
    }
  return;
}



/* public */



q_type make_empty_queue ()
{
  return (NULL);
}



int not_empty_queue (q_type q) 
/* returns (0) if queue is empty or (1) otherwise */
{
  return (q != NULL);
}



void enqueue (q_type *q, int key, int depth_s, int L, char **vect, int absize)
{
  q_node *node;
  node = make_queue_node(key, depth_s, L, vect, absize);
  node->next = *q;
  *q = node;
  return;
}



void dequeue (q_type *q, int *key, int *depth_s, int L, char **vect, char *c)
{
  q_type oldq;
  int i;
  if (*q != NULL)
    {
      *key = (*q)->key;
      *depth_s = (*q)->depth_s;
      *c = (*q)->v[*depth_s-1][0];
      for (i=0;i<(*depth_s);i++)
	strcpy(vect[L-i-1], (*q)->v[i]);
      oldq = (*q);
      *q = (*q)->next;
      free_queue_node(oldq);
    }
  else
    {
      fprintf (stderr,"dequeue: empty queue\n");
      exit(1);
    }      
  return;
}





