/* Training a SPST */


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "file_handle.h"
#include "learn_alg.h"


extern int N_min;
extern double r_max;
extern int L_max;


int main (int argc, char **argv)
{


int i;
int absize, m, *li, test_size;
int train_size, train_len;
char *AB, *train_set, *ab_file, *strings_file;
char *output_file, *index_file;
char **ts_ptr;
spst_type T;


switch (argc)
{
 case 1:  /* short reminder */
   system("clear");
   printf(" (clear screen)\n");
   fprintf(stderr,"GENERAL call format:\n\nGrowing trees:\n\n");
   fprintf(stderr," %s <ab_file> <strings_file> <index_file/@> ...\n",argv[0]);
   fprintf(stderr,"\t...<output_file> <N_min> <r_max> <L_max>\n\n");
   fprintf(stderr,"<strings_file> should be in FASTA format.\n");
   fprintf(stderr,"<index_file>   entries: 0 = read, other = ignore (no index => read all)\n");
   fprintf(stderr,"<.../@>        if file name starts with '@' it is ignored.\n");
   exit(1);
   
 case 8: /* alg */
   ab_file = argv[1];
   strings_file = argv[2];
   index_file = argv[3];
   output_file = argv[4];
   N_min = atoi(argv[5]);
   r_max = atof(argv[6]);
   L_max = atoi(argv[7]);
   break;
   
 default:
   fprintf(stderr,"Syntax Error: type %s for a short reminder\n",argv[0]);
   exit(1);
}
 
 read_alphabet(&absize,&AB,ab_file);
 read_fasta_set(&train_set, &m, &ts_ptr, &li, AB, strings_file, \
		index_file, &test_size, &train_size, &train_len);
 T = grow_tree(AB, absize, m, ts_ptr, train_len);
 save_spst(output_file, AB, absize, L_max, T);
 return(0);
}    


